Imports Microsoft.Win32
Imports System.Collections.Generic
Imports System.Data
Imports System.IO
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks

Public Class AccessDataSource
	Friend Sub New()
	End Sub

	Private Function GetDBPath(dbName As String) As String
		Dim dbPath As String = String.Empty
		Dim fileName As String = String.Format("\{0}", dbName)
		Dim regKey As RegistryKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\Common7")
		If regKey IsNot Nothing Then
			dbPath = DirectCast(regKey.GetValue("v" & GCVersionUtil.ProductVersion), String)
		End If
		If Not File.Exists(dbPath & fileName) Then
			dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) & GCVersionUtil.SPREAD_INSTALLATION_FOLDER & "\Common\"
		End If
		If Not File.Exists(dbPath & fileName) Then
			dbPath = "Data\"
		End If
		dbPath += fileName
		Return dbPath
	End Function

	Public Function GetNWINDData(dataTable As String) As DataSet
		Dim sqlStr As String = String.Format("Select*From `{0}`", dataTable)
		Return GetNWINDDataComplete(sqlStr)
	End Function

	Public Function GetNWINDDataComplete(query As String) As DataSet
		Return GetDataFrom("Nwind.mdb", query)
	End Function

	Public Function GetDataFrom(dbName As String, query As String) As DataSet
		Dim conStr As String = "Provider=Microsoft.JET.OLEDB.4.0;data source=" & GetDBPath(dbName)
		Dim conn As New System.Data.OleDb.OleDbConnection(conStr)
		Dim ds As New DataSet()
		Dim da As New System.Data.OleDb.OleDbDataAdapter(query, conn)
		da.Fill(ds)
		Return ds
	End Function

	Public Function GetDataFromTable(dbName As String, dataTable As String) As DataSet
		Dim sqlStr As String = String.Format("Select * From `{0}`", dataTable)
		Return GetDataFrom(dbName, sqlStr)
	End Function
End Class


