Imports Spread.Common.DataStore.Model
Imports System.Linq

Namespace DataSourceEntities
	Public Class COGSDataSource
		#Region "Public methods"
		Public Function GetCOGSStats(seedDate As DateTime, revenueCategoryCount As Integer, costCategoryCount As Integer) As CostOfGoodsStats
			Dim random As New Random(CInt(Math.Truncate(seedDate.ToOADate())))
			Dim stats As New CostOfGoodsStats()

			For i As Integer = 0 To revenueCategoryCount - 1
				stats.CategoryRevenues.Add(random.[Next](120000, 250000))
			Next

			For i As Integer = 0 To costCategoryCount - 1
				stats.CategoryCosts.Add(random.[Next](50000, 160000))
			Next

			stats.Expenses.SalaryExpenses = random.[Next](40000, 60000)
			stats.Expenses.PayrollExpenses = random.[Next](5000, 10000)
			stats.Expenses.OutsideServices = random.[Next](4000, 7000)
			stats.Expenses.Supplies = random.[Next](10000, 15000)
			stats.Expenses.Repairs = random.[Next](2000, 5000)
			stats.Expenses.Advertising = random.[Next](5000, 10000)
			stats.Expenses.CarDelivery = random.[Next](1000, 3000)
			stats.Expenses.Accounting = random.[Next](2000, 4000)
			stats.Expenses.Rent = random.[Next](10000, 13000)
			stats.Expenses.Telephone = random.[Next](3000, 4000)
			stats.Expenses.Utilities = random.[Next](2000, 4000)
			stats.Expenses.Insurance = random.[Next](3000, 4000)
			stats.Expenses.Taxes = CInt(Math.Truncate(0.17 * stats.CategoryRevenues.Sum()))
			stats.Expenses.Interest = random.[Next](1000, 2000)
			stats.Expenses.Depreciation = random.[Next](500, 1200)

			For i As Integer = 0 To 2
				stats.Expenses.Others.Add(random.[Next](200, 600))
			Next

			stats.Expenses.Miscellaneous = random.[Next](1200, 2000)

			Return stats
		End Function
		#End Region
	End Class
End Namespace
