Imports Newtonsoft.Json.Converters
Imports Spread.Common.DataStore.Models
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports Spread.Common.DataStore.Utilities
Imports Newtonsoft.Json
Imports Spread.Common.DataStore.Spread.Common.DataStore.Models

Namespace Spread.Common.DataStore
    Public Class DashBoardDataSource
        Public Function LoadDashBoardItems() As DashBoardItems
            Dim dashBoardItems As DashBoardItems = New DashBoardItems()
            Dim format = "dd/MM/yyyy"
            Dim dateTimeConverter = New IsoDateTimeConverter With {
        .DateTimeFormat = format
    }
            Dim jsonStr As String = FileUtilities.LoadJSON("Companies.json")

            dashBoardItems.Companies = JsonConvert.DeserializeObject(Of List(Of Company))(jsonStr, dateTimeConverter)
            jsonStr = FileUtilities.LoadJSON("DashBoardCustomers.json")

            dashBoardItems.Customers = JsonConvert.DeserializeObject(Of List(Of Customer))(jsonStr, dateTimeConverter)
            jsonStr = FileUtilities.LoadJSON("CustomerTarget.json")

            dashBoardItems.CustomerTargets = JsonConvert.DeserializeObject(Of List(Of CustomerTarget))(jsonStr, dateTimeConverter)
            AssignYearToData(dashBoardItems.CustomerTargets.Cast(Of IDateTime).ToList())

            jsonStr = FileUtilities.LoadJSON("DashBoardInvoices.json")
            dashBoardItems.Invoices = JsonConvert.DeserializeObject(Of List(Of Invoice))(jsonStr, dateTimeConverter)
            AssignDateToInvoice(dashBoardItems.Invoices)
            jsonStr = FileUtilities.LoadJSON("MarketSales.json")
            dashBoardItems.MarketSales = JsonConvert.DeserializeObject(Of List(Of MarketSale))(jsonStr, dateTimeConverter)
            AssignYearToData(dashBoardItems.MarketSales.Cast(Of IDateTime).ToList())
            jsonStr = FileUtilities.LoadJSON("Products.json")
            dashBoardItems.Products = JsonConvert.DeserializeObject(Of List(Of Product))(jsonStr, dateTimeConverter)

            jsonStr = FileUtilities.LoadJSON("Regions.json")
            dashBoardItems.Regions = JsonConvert.DeserializeObject(Of List(Of Region))(jsonStr, dateTimeConverter)
            AssignYearToData(dashBoardItems.Regions.Cast(Of IDateTime).ToList())

            jsonStr = FileUtilities.LoadJSON("Sales.json")
            dashBoardItems.Sales = JsonConvert.DeserializeObject(Of List(Of Sale))(jsonStr, dateTimeConverter)

            jsonStr = FileUtilities.LoadJSON("DashBoardTargetMaster.json")
            dashBoardItems.TargetMasters = JsonConvert.DeserializeObject(Of List(Of DashBoardTargetMaster))(jsonStr, dateTimeConverter)
            AssignYearToData(dashBoardItems.TargetMasters.Cast(Of IDateTime).ToList())

            UpdateActualSaleForCompany(dashBoardItems)
            Return dashBoardItems
        End Function


        Private Sub AssignDateToInvoice(ByVal invoiceList As List(Of Invoice))
            invoiceList = invoiceList.OrderBy(Function(c) c.ID).ToList()
            Dim calcMonth As Integer = 1
            Dim currentYr As Integer = DateTime.Now.Year
            Dim currentMonth As Integer = DateTime.Now.Month
            Dim count As Integer = invoiceList.Count()
            Dim rand As Random = New Random()

            For Each item As Invoice In invoiceList
                Dim itemID = Double.Parse(item.ID)
                Dim d As Double = itemID / (count / 24)
                calcMonth = CInt(Math.Ceiling(d))

                If calcMonth <= currentMonth AndAlso itemID <= (count / 2) Then
                    item.CreatedOn = New DateTime(currentYr, calcMonth, rand.[Next](1, 28))
                ElseIf itemID <= (count / 2) Then
                    item.CreatedOn = New DateTime(currentYr - 2, calcMonth, rand.[Next](1, 28))
                Else
                    item.CreatedOn = New DateTime(currentYr - 1, calcMonth - 12, rand.[Next](1, 28))
                End If
            Next
        End Sub

        Private Sub AssignYearToData(ByVal list As List(Of IDateTime))
            list = list.OrderBy(Function(c) c.Id).ToList()
            Dim currentYr As Integer = DateTime.Now.Year
            Dim currentMonth As Integer = DateTime.Now.Month
            Dim count As Integer = list.Count()

            For Each item As IDateTime In list

                If currentMonth >= item.Month AndAlso item.Id <= (count / 2) Then
                    item.Year = currentYr
                ElseIf item.Id <= (count / 2) Then
                    item.Year = currentYr - 2
                Else
                    item.Year = currentYr - 1
                End If
            Next
        End Sub

        Private Sub UpdateActualSaleForCompany(ByVal dashBoardItems As DashBoardItems)
            For Each marketSale As MarketSale In dashBoardItems.MarketSales

                If marketSale.CompId = 3 Then
                    ' If marketSale.Year And marketSale.Month. Then
                    marketSale.TotalSale = CDbl(dashBoardItems.Invoices.Where(Function(i) i.CreatedOn.Month = marketSale.Month AndAlso i.CreatedOn.Year = marketSale.Year).Sum(Function(i) i.TotalAmount))
                    ' End If
                End If
            Next
        End Sub
    End Class
End Namespace
