Imports Newtonsoft.Json
Imports Newtonsoft.Json.Linq
Imports Spread.Common.DataStore.Models
Imports Spread.Common.DataStore.Utilities
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks

Namespace DataSourceEntities
	Public Class FinancialKPIDataSource
		#Region "Private methods"
		Private Sub UpdateDatesInData(targetMasterList As List(Of FinancialTargetMaster))
			Dim currentMonth As Integer = DateTime.Now.Month
			Dim currentYr As Integer = DateTime.Now.Year

			Dim sampleTarget As FinancialTargetMaster = targetMasterList.Last()
			Dim random As New Random()

            For Each target As Object In targetMasterList.OrderByDescending(Function(t) t.Year).ThenByDescending(Function(t) t.Month)
                target.Month = currentMonth
                target.Year = currentYr
                currentMonth -= 1
                If currentMonth = 0 Then
                    currentMonth = 12
                    currentYr -= 1
                End If
            Next
        End Sub
		#End Region

		#Region "Public methods"
		Public Function GetAllKPIs() As FinancialKPIList
			Dim json As String = FileUtilities.LoadJSON("FinancialKPIList.json")
			Dim kpiList As FinancialKPIList = JsonConvert.DeserializeObject(Of FinancialKPIList)(json)
			Return kpiList
		End Function

		Public Function GetAllTargets() As List(Of FinancialTargetMaster)
			Dim json As String = FileUtilities.LoadJSON("FinancialTargetMaster.json")
			Dim parsedObject = JObject.Parse(json)
			Dim financialData As String = parsedObject("FinancialKPI").ToString()
			Dim targetMasterList As List(Of FinancialTargetMaster) = JsonConvert.DeserializeObject(Of List(Of FinancialTargetMaster))(financialData)
			UpdateDatesInData(targetMasterList)
			Return targetMasterList
		End Function
		#End Region
	End Class
End Namespace
