Imports System.Collections.Generic
Imports System.Linq
Imports Newtonsoft.Json
Imports Spread.Common.DataStore.Models
Imports Spread.Common.DataStore.Utilities

Namespace DataSourceEntities
	Public Class IncomeStatementDataSource
		#Region "Public methods"
		' Get a List of all BusinessStat from JSON
		Public Function GetAllBusinessStats() As List(Of BusinessStat)
			Dim json As String = FileUtilities.LoadJSON("BusinessStats.json")
			Dim stats As List(Of BusinessStat) = JsonConvert.DeserializeObject(Of List(Of BusinessStat))(json)

			UpdateYearInStats(stats)

			Return stats
		End Function
		#End Region

		#Region "Private methods"
		' Update 'Year' Property of BusinessStat to keep the data current
		Private Sub UpdateYearInStats(stats As IEnumerable(Of BusinessStat))
			stats = stats.OrderByDescending(Function(stat) stat.Year).ThenBy(Function(stat) stat.Month).AsEnumerable()

			Dim diff As Integer = DateTime.Now.Year - stats.First().Year

            For Each stat As Object In stats
                stat.Year = stat.Year + diff
            Next
        End Sub
		#End Region
	End Class
End Namespace
