Imports Newtonsoft.Json
Imports Newtonsoft.Json.Linq
Imports Spread.Common.DataStore.Models
Imports Spread.Common.DataStore.Utilities
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Public Class KPIDataSource
	Public Function GetAllKPIs() As KPIList
		Dim json As String = FileUtilities.LoadJSON("FinancialKPIList.json")
		Dim kpiList As KPIList = JsonConvert.DeserializeObject(Of KPIList)(json)
		Return kpiList
	End Function

	'Get all targets
	Public Function GetAllTargets() As List(Of TargetMaster)
		Dim json As String = FileUtilities.LoadJSON("FinancialTargetMaster.json")
		Dim parsedObject = JObject.Parse(json)
		Dim businessData As String = parsedObject("BusinessKPI").ToString()
		Dim targetMasterList As List(Of TargetMaster) = JsonConvert.DeserializeObject(Of List(Of TargetMaster))(businessData)
		UpdateDatesInTargetData(targetMasterList)
		Return targetMasterList
	End Function

	Private Sub UpdateDatesInTargetData(targetMasterList As List(Of TargetMaster))
		Dim currentMonth As Integer = DateTime.Now.Month
		Dim currentYr As Integer = DateTime.Now.Year

		For Each target As TargetMaster In targetMasterList.OrderByDescending(Function(t) t.Year).ThenByDescending(Function(t) t.Month)
			target.Month = currentMonth
			target.Year = currentYr
			currentMonth -= 1
			If currentMonth = 0 Then
				currentMonth = 12
				currentYr -= 1
			End If
		Next
		'UpdateDataInTargetJsonFile(targetMasterList);
		'Assign 0 in data for all previous month in year
		While currentMonth > 0 AndAlso currentMonth <> 12
            Dim target As New TargetMaster() With {
                .Year = currentYr,
                .Month = currentMonth,
                .KPITargets = New List(Of KPIMetrics)()
            }
            For Each item As Object In GetAllKPIs().Items
                target.KPITargets.Add(New KPIMetrics() With {
                     .KPIId = item.Key,
                     .Actual = 0,
                     .Target = 0
                })
            Next
            targetMasterList.Add(target)
			currentMonth -= 1
		End While
	End Sub
	'Update data in TargetMaster json file with date
	Private Sub UpdateDataInTargetJsonFile(targetMasterList As List(Of TargetMaster))
		FileUtilities.WriteToJSON("TargetMaster.json", JsonConvert.SerializeObject(targetMasterList, Formatting.Indented))
	End Sub
End Class
