Imports System.Collections.Generic
Imports System.Data
Imports System.Data.OleDb
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks

Public Class OrderEntryDataSource
	Private _dataSource As AccessDataSource

	Friend Sub New()
		_dataSource = New AccessDataSource()
	End Sub

	Public Function FindCustomers(parameters As Dictionary(Of String, String)) As DataTable
		Dim query As String = "select * from Customers {BuildQuery(parameters)}"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function FindOrders(parameters As Dictionary(Of String, String)) As DataTable
		Dim query As String = "select * from Orders {BuildQuery(parameters)}"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function FindProducts(parameters As Dictionary(Of String, String)) As DataTable
		Dim query As String = "select * from Products {BuildQuery(parameters)}"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function FindEmployees(parameters As Dictionary(Of String, String)) As DataTable
		Dim query As String = "select * from Employees {BuildQuery(parameters)}"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function FindOrderDetails(parameters As Dictionary(Of String, String)) As DataTable
		Dim query As String = "select * from Orders Inner Join OrderDetails on Orders.OrderID = OrderDetails.OrderNum" & " {BuildQuery(parameters)}"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function GetOpenInvoices() As DataTable
		Dim query As String = "Select * from Receivables where [AccountOpen] = -1 ORDER By Company Asc, OrderDate Asc"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function GetSalesReportByDate(beginDate As DateTime, endDate As DateTime) As DataTable
		Dim query As String = "select OrderDate, OrderSubtotal, Freight, OrderTax,OrderTotal from Orders where OrderDate " & "between #" & beginDate & "# and #" & endDate & "# Order By OrderDate ASC"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function GetSalesReportByProduct(beginDate As DateTime, endDate As DateTime) As DataTable
		Dim query As String = "select OD.ProductID, OD.Description, OD.UnitPrice, OD.Quantity, OD.LineTotal "
		query += "from OrderDetails OD INNER JOIN Orders O on OD.OrderNum = O.OrderID "
		query += "where O.OrderDate between #" & beginDate & "# and #" & endDate & "#" & "ORDER BY OD.ProductID"
		Dim table As DataTable = _dataSource.GetDataFrom("fpWine.mdb", query).Tables(0)
		Return table
	End Function

	Public Function AddCustomer(companyName As String, contactName As String, contactTitle As String, address As String, address2 As String, city As String, _
		region As String, postalCode As String, country As String, phone As String, fax As String, email As String, _
		discount As Object) As Integer
		Dim connStr As String = GetConnectionString(GetDBPath("fpWine.mdb"))
		Dim query As String = "insert into Customers (CompanyName, ContactName, ContactTitle, Address, Address2, City, Region, PostalCode," & "Country, Phone, Fax, email, discount) Values ('{CorrectString(companyName)}', '{CorrectString(contactName)}'," & "'{CorrectString(contactTitle)}', '{CorrectString(address)}', '{CorrectString(address2)}'," & "'{CorrectString(city)}', '{CorrectString(region)}', '{CorrectString(postalCode)}', '{CorrectString(country)}'," & "'{CorrectString(phone)}', '{CorrectString(fax)}', '{CorrectString(email)}', '{CorrectValue(discount)}')"

		Dim result As Integer = -1
		Using connection As New OleDbConnection(connStr)
			Using command As New OleDbCommand(query, connection)
				connection.Open()
				result = command.ExecuteNonQuery()
				connection.Close()
			End Using
		End Using
		Return result
	End Function

	Public Function UpdateCustomer(custID As Integer, companyName As String, contactName As String, contactTitle As String, address As String, address2 As String, _
		city As String, region As String, postalCode As String, country As String, phone As String, fax As String, _
		email As String, discount As Object) As Integer
		Dim connStr As String = GetConnectionString(GetDBPath("fpWine.mdb"))
		Dim query As String = "update Customers set CompanyName = '{CorrectString(companyName)}', ContactName = '{CorrectString(contactName)}'," & "ContactTitle = '{CorrectString(contactTitle)}', Address = '{CorrectString(address)}'," & "Address2 = '{CorrectString(address2)}', City = '{CorrectString(city)}', Region = '{CorrectString(region)}'," & "PostalCode = '{CorrectString(postalCode)}', Country = '{CorrectString(country)}', Phone = '{CorrectString(phone)}'," & "Fax = '{CorrectString(fax)}', email = '{CorrectString(email)}', discount = '{CorrectValue(discount)}' " & "where ID = {custID}"

		Dim result As Integer = -1
		Using connection As New OleDbConnection(connStr)
			Using command As New OleDbCommand(query, connection)
				connection.Open()
				result = command.ExecuteNonQuery()
				connection.Close()
			End Using
		End Using
		Return result
	End Function

	Public Function AddOrder(CustomerID As Integer, SalesPerson As String, ShipMethod As String, Freight As Decimal, ShipCompany As String, ShipName As String, _
		ShipAddress As String, ShipAddress2 As String, ShipCity As String, ShipRegion As String, ShipPostalCode As String, ShipCountry As String, _
		ShipPhone As String, BillCompany As String, BillName As String, BillAddress As String, BillAddress2 As String, BillCity As String, _
		BillRegion As String, BillPostalCode As String, BillCountry As String, BillPhone As String, PaymentMethod As String, PaymentNumber As String, _
		CardExpDate As String, CardholderName As String, OrderSubTotal As Decimal, OrderTotal As Decimal, AmtPaid As Decimal, BalanceDue As Decimal, _
		OrderTax As Decimal) As Integer
		Dim connStr As String = GetDBPath("fpWine.mdb")
		Dim query As String = "insert into Orders (CustomerID, SalesPerson, OrderDate, ShipMethod, Freight, ShipCompany," & "ShipName, ShipAddress, ShipAddress2, ShipCity, ShipRegion, ShipPostalCode, ShipCountry, ShipPhone," & "BillCompany, BillName, BillAddress, BillAddress2, BillCity, BillRegion, BillPostalCode, BillCountry," & "BillPhone, PaymentMethod, PaymentNumber, CardExpDate, CardholderName, OrderSubTotal, OrderTotal, AmtPaid," & "BalanceDue, OrderTax) Values ('{CustomerID.ToString()}', '{SalesPerson}', '{DateTime.Today.ToString()}'," & "'{ShipMethod}', '{CorrectValue(Freight)}', '{CorrectString(ShipCompany)}', '{CorrectString(ShipName)}'," & "'{CorrectString(ShipAddress)}', '{CorrectString(ShipAddress2)}', '{CorrectString(ShipCity)}'," & "'{CorrectString(ShipRegion)}', '{CorrectString(ShipPostalCode)}', '{CorrectString(ShipCountry)}'," & "'{CorrectString(ShipPhone)}', '{CorrectString(BillCompany)}', '{CorrectString(BillName)}', '{CorrectString(BillAddress)}'," & "'{CorrectString(BillAddress2)}', '{CorrectString(BillCity)}', '{CorrectString(BillRegion)}'," & "'{CorrectString(BillPostalCode)}', '{CorrectString(BillCountry)}', '{CorrectString(BillPhone)}'," & "'{PaymentMethod}', '{CorrectString(PaymentNumber)}', '{CorrectString(CardExpDate)}', '{CorrectString(CardholderName)}'," & "'{CorrectValue(OrderSubTotal)}', '{CorrectValue(OrderTotal)}', '{CorrectValue(AmtPaid)}'," & "'{CorrectValue(BalanceDue)}', '{CorrectValue(OrderTax)}')"

		Dim result As Integer = -1
		Using connection As New OleDbConnection(connStr)
			Using command As New OleDbCommand(query, connection)
				result = command.ExecuteNonQuery()
			End Using
		End Using
		Return result
	End Function

	Public Function UpdateOrder(OrderID As Integer, SalesPerson As String, ShipMethod As String, Freight As Decimal, ShipCompany As String, ShipName As String, _
		ShipAddress As String, ShipAddress2 As String, ShipCity As String, ShipRegion As String, ShipPostalCode As String, ShipCountry As String, _
		ShipPhone As String, BillCompany As String, BillName As String, BillAddress As String, BillAddress2 As String, BillCity As String, _
		BillRegion As String, BillPostalCode As String, BillCountry As String, BillPhone As String, PaymentMethod As String, PaymentNumber As String, _
		CardExpDate As String, CardholderName As String, OrderSubTotal As Decimal, OrderTotal As Decimal, AmtPaid As Decimal, BalanceDue As Decimal, _
		OrderTax As Decimal) As Integer
		Dim connStr As String = GetConnectionString(GetDBPath("fpWine.mdb"))
		Dim query As String = "update Orders set SalesPerson = '{SalesPerson}', ShipMethod = '{ShipMethod}', Freight = '{CorrectValue(Freight)}'," & "ShipCompany = '{CorrectString(ShipCompany)}', ShipName = '{CorrectString(ShipName)}', ShipAddress = '{CorrectString(ShipAddress)}'," & "ShipAddress2 = '{CorrectString(ShipAddress2)}', ShipCity = '{CorrectString(ShipCity)}', ShipRegion = '{CorrectString(ShipRegion)}'," & "ShipPostalCode = '{CorrectString(ShipPostalCode)}', ShipCountry = '{CorrectString(ShipCountry)}'," & "ShipPhone = '{CorrectString(ShipPhone)}', BillCompany = '{CorrectString(BillCompany)}', BillName = '{CorrectString(BillName)}'," & "BillAddress = '{CorrectString(BillAddress)}', BillAddress2 = '{CorrectString(BillAddress2)}', BillCity = '{CorrectString(BillCity)}'," & "BillRegion = '{CorrectString(BillRegion)}', BillPostalCode = '{CorrectString(BillPostalCode)}', BillCountry = '{CorrectString(BillCountry)}'," & "BillPhone = '{CorrectString(BillPhone)}', PaymentMethod = '{PaymentMethod}', PaymentNumber = '{CorrectString(PaymentNumber)}'," & "CardExpDate = '{CorrectString(CardExpDate)}', CardholderName = '{CorrectString(CardholderName)}', OrderSubTotal = '{CorrectValue(OrderSubTotal)}'," & "OrderTotal = '{CorrectValue(OrderTotal)}', AmtPaid = '{CorrectValue(AmtPaid)}', BalanceDue = '{CorrectValue(BalanceDue)}'," & "OrderTax = '{CorrectValue(OrderTax)}' where OrderID = {OrderID}"

		Dim result As Integer = -1
		Using connection As New OleDbConnection(connStr)
			Using command As New OleDbCommand(query, connection)
				connection.Open()
				result = command.ExecuteNonQuery()
				connection.Close()
			End Using
		End Using
		Return result
	End Function

	Public Function DeleteLineItem(orderNum As Integer) As Integer
		Dim connStr As String = GetConnectionString(GetDBPath("fpWine.mdb"))
		Dim query As String = "delete from OrderDetails where OrderNum = {orderNum}"
		Dim result As Integer = -1
		Using connection As New OleDbConnection(connStr)
			Using command As New OleDbCommand(query, connection)
				connection.Open()
				result = command.ExecuteNonQuery()
				connection.Close()
			End Using
		End Using
		Return result
	End Function

	Public Function AddLineItem(OrderNum As Integer, ProductID As Integer, Description As String, UnitPrice As Decimal, LineTotal As Decimal, Quantity As Integer, _
		Discount As Decimal) As Integer
		Dim connStr As String = GetConnectionString(GetDBPath("fpWine.mdb"))
		Dim query As String = "insert into OrderDetails (OrderNum,ProductID,Description,UnitPrice,LineTotal,Quantity,Discount) " & "Values ('{OrderNum}', '{CorrectValue(ProductID)}', '{CorrectString(Description)}', '{CorrectValue(UnitPrice)}'," & "'{CorrectValue(LineTotal)}', '{CorrectValue(Quantity)}', '{CorrectValue(Discount)}')"
		Dim result As Integer = -1
		Using connection As New OleDbConnection(connStr)
			Using command As New OleDbCommand(query, connection)
				connection.Open()
				result = command.ExecuteNonQuery()
				connection.Close()
			End Using
		End Using
		Return result
	End Function

	Private Function BuildQuery(parameters As Dictionary(Of String, String)) As String
		Dim query As String = String.Empty
		If parameters.Any() Then
			query = "where "
		End If

		Dim args As New List(Of String)()

        For Each entry As Object In parameters
            If entry.Key.Contains("ID") OrElse entry.Key.Contains("Num") Then
                args.Add("{entry.Key} = {entry.Value}")
            Else
                args.Add("{entry.Key} like '{entry.Value}%'")
            End If
        Next

        query += [String].Join(" and ", args)
		Return query
	End Function

	Private Function GetConnectionString(dbPath As String) As String
		Return [String].Format("Provider=Microsoft.Jet.OLEDB.4.0; Data Source={0}", dbPath)
	End Function

	Private Function GetDBPath(dbName As String) As String
		Dim dbPath As String = String.Empty
		Dim fileName As String = String.Format("{0}", dbName)
		Dim regKey As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\Common7")
		If regKey IsNot Nothing Then
			dbPath = DirectCast(regKey.GetValue("v" & GCVersionUtil.ProductVersion), String)
		End If
		If Not System.IO.File.Exists(dbPath & fileName) Then
			dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) & GCVersionUtil.SPREAD_INSTALLATION_FOLDER & "\Common\"
		End If
		If Not System.IO.File.Exists(dbPath & fileName) Then
			dbPath = "Data\"
		End If
		dbPath += fileName
		Return dbPath
	End Function

	Public Function CorrectString(str As Object) As String
		Dim newstr As String
		If str Is Nothing OrElse str Is DBNull.Value Then
			str = String.Empty
		End If

		newstr = DirectCast(str, String).Replace("'", "''")
		newstr = (newstr).Replace(" ", "")
		Return newstr
	End Function

	Public Function CorrectValue(str As Object) As Double
		Dim newstr As Double = 0
		If str Is Nothing OrElse str Is DBNull.Value Then
			newstr = 0
		Else
			newstr = Convert.ToDouble(str)
		End If

		Return newstr
	End Function
End Class
