Imports Newtonsoft.Json
Imports Spread.Common.DataStore.Models
Imports Spread.Common.DataStore.Utilities
Imports System.Collections
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks

Namespace DataSourceEntities
    Public Class StudentDashboardDataSource
#Region "Public methods"
        ' Get a List of all Students
        Public Function GetAllStudents() As List(Of Student)
            Dim json As String = FileUtilities.LoadJSON("Students.json")
            Dim students As List(Of Student) = JsonConvert.DeserializeObject(Of List(Of Student))(json)
            Return students
        End Function

        ' Get a List of all Absence Records
        Public Function GetAllAbsentRecords() As List(Of AbsentRecords)
            Dim json As String = FileUtilities.LoadJSON("AbsentRecords.json")
            Dim absentRecords As List(Of AbsentRecords) = JsonConvert.DeserializeObject(Of List(Of AbsentRecords))(json)

            absentRecords = absentRecords.OrderBy(Function(r) r.SessionID).ToList()
            Dim diff As Integer = DateTime.Now.Year - 2018

            ' Update dates of each record to keep it current
            If diff <> 0 Then
                For Each list1 As AbsentRecords In absentRecords
                    list1.StudentRecords = list1.StudentRecords.OrderBy(Function(r) r.StudentID).ThenBy(Function(r) r.[Date]).ToList()
                    For Each record As AbsentRecord In list1.StudentRecords
                        If DateTime.IsLeapYear(record.[Date].Year) AndAlso record.[Date].Month = 2 AndAlso record.[Date].Day = 29 Then
                            record.[Date] = New DateTime(record.[Date].Year + diff, record.[Date].Month + 1, 1)
                        Else
                            record.[Date] = New DateTime(record.[Date].Year + diff, record.[Date].Month, record.[Date].Day)
                        End If
                    Next
                Next
            End If

            Return absentRecords
        End Function

        ' Get a List of all Tardy Records
        Public Function GetAllTardyRecords() As List(Of TardyRecords)
            Dim json As String = FileUtilities.LoadJSON("TardyRecords.json")
            Dim tardyRecords As List(Of TardyRecords) = JsonConvert.DeserializeObject(Of List(Of TardyRecords))(json)

            tardyRecords = tardyRecords.OrderBy(Function(r) r.SessionID).ToList()
            Dim diff As Integer = DateTime.Now.Year - 2018

            ' Update dates of each record to keep it current
            If diff <> 0 Then
                For Each list As TardyRecords In tardyRecords
                    list.StudentRecords = list.StudentRecords.OrderBy(Function(r) r.StudentID).ThenBy(Function(r) r.[Date]).ToList()
                    For Each record As TardyRecord In list.StudentRecords
                        If DateTime.IsLeapYear(record.[Date].Year) AndAlso record.[Date].Month = 2 AndAlso record.[Date].Day = 29 Then
                            record.[Date] = New DateTime(record.[Date].Year + diff, record.[Date].Month + 1, 1)
                        Else
                            record.[Date] = New DateTime(record.[Date].Year + diff, record.[Date].Month, record.[Date].Day)
                        End If
                    Next
                Next
            End If

            Return tardyRecords
        End Function

        ' Get a List of all Score Records
        Public Function GetAllScoreRecords() As List(Of ScoreRecords)
            Dim json As String = FileUtilities.LoadJSON("ScoreRecords.json")
            Dim scoreRecords As List(Of ScoreRecords) = JsonConvert.DeserializeObject(Of List(Of ScoreRecords))(json)
            Return scoreRecords
        End Function

        ' Get a List of all Term Sessions
        Public Function GetAllTermSessions() As List(Of TermSession)
            Dim json As String = FileUtilities.LoadJSON("TermSessions.json")
            Dim termSessions As List(Of TermSession) = JsonConvert.DeserializeObject(Of List(Of TermSession))(json)

            ' Update Year of each Term Session to keep it current
            Dim diff As Integer = DateTime.Now.Year - 2018
            If diff <> 0 Then
                For Each session As Object In termSessions
                    session.Year += diff
                Next
            End If

            Return termSessions
        End Function
#End Region
    End Class
End Namespace
