Imports Newtonsoft.Json
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks

Namespace Models
	Public Class FinancialKPI
		Public Property Name() As String
			Get
				Return m_Name
			End Get
			Set
				m_Name = Value
			End Set
		End Property
		Private m_Name As String
		Public Property Type() As KPIType
			Get
				Return m_Type
			End Get
			Set
				m_Type = Value
			End Set
		End Property
		Private m_Type As KPIType
	End Class

	Public Enum KPIType As Byte
		Asset = 0
		Liability = 1
	End Enum

	Public Class FinancialKPIList
		#Region "Properties"
		<JsonProperty("FinancialKPIItems")> _
		Public Property Items() As Dictionary(Of Integer, FinancialKPI)
			Get
				Return m_Items
			End Get
			Set
				m_Items = Value
			End Set
		End Property
		Private m_Items As Dictionary(Of Integer, FinancialKPI)
		#End Region

		#Region "ctor"
		Public Sub New()
			Items = New Dictionary(Of Integer, FinancialKPI)()
		End Sub
		#End Region
	End Class

	Public Class FinancialKPIMetrics
		#Region "Properties"
		Public Property KPIId() As Integer
			Get
				Return m_KPIId
			End Get
			Set
				m_KPIId = Value
			End Set
		End Property
		Private m_KPIId As Integer
		Public Property Actual() As Double
			Get
				Return m_Actual
			End Get
			Set
				m_Actual = Value
			End Set
		End Property
		Private m_Actual As Double
		Public Property Target() As Double
			Get
				Return m_Target
			End Get
			Set
				m_Target = Value
			End Set
		End Property
		Private m_Target As Double
		#End Region
	End Class

	Public Class FinancialTargetMaster
		#Region "Fields"
		Private _month As Integer
		Private _year As Integer
		#End Region

		#Region "Properties"
		<JsonProperty("FinancialKPITargets")> _
		Public Property KPITargets() As List(Of FinancialKPIMetrics)
			Get
				Return m_KPITargets
			End Get
			Set
				m_KPITargets = Value
			End Set
		End Property
		Private m_KPITargets As List(Of FinancialKPIMetrics)

		Public Property Month() As Integer
			Get
				Return _month
			End Get
			Set
				If value < 1 OrElse value > 12 Then
					Throw New NotSupportedException("Value not supported." & vbLf & "Expected Value: 1 to 12" & vbLf & "Actual Value: " & value)
				End If
				_month = value
			End Set
		End Property

		Public Property Year() As Integer
			Get
				Return _year
			End Get
			Set
				If value < 1000 OrElse value > 9999 Then
					Throw New NotSupportedException("Value not supported." & vbLf & "Expected Value: 1000 to 9999" & vbLf & "Actual Value: " & value)
				End If
				_year = value
			End Set
		End Property
		#End Region

		#Region "ctor"
		Public Sub New()
			KPITargets = New List(Of FinancialKPIMetrics)()
		End Sub
		#End Region
	End Class
End Namespace
