Imports Newtonsoft.Json
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Namespace Models
	Public Class KPIList
		Public Sub New()
			Items = New Dictionary(Of Integer, String)()
		End Sub

		<JsonProperty("BusinessKPIItems")> _
		Public Property Items() As Dictionary(Of Integer, String)
			Get
				Return m_Items
			End Get
			Set
				m_Items = Value
			End Set
		End Property
		Private m_Items As Dictionary(Of Integer, String)
	End Class

	Public Class KPIMetrics
		Public Property KPIId() As Integer
			Get
				Return m_KPIId
			End Get
			Set
				m_KPIId = Value
			End Set
		End Property
		Private m_KPIId As Integer
		Public Property Actual() As Double
			Get
				Return m_Actual
			End Get
			Set
				m_Actual = Value
			End Set
		End Property
		Private m_Actual As Double
		Public Property Target() As Double
			Get
				Return m_Target
			End Get
			Set
				m_Target = Value
			End Set
		End Property
		Private m_Target As Double
	End Class

	Public Class TargetMaster
		Private _month As Integer
		Private _year As Integer

		Public Sub New()
			KPITargets = New List(Of KPIMetrics)()
		End Sub

		Public Property Month() As Integer
			Get
				Return _month
			End Get
			Set
				If value < 1 OrElse value > 12 Then
					Throw New NotSupportedException("Value not supported." & vbLf & "Expected Value: 1 to 12" & vbLf & "Actual Value: " & value)
				End If
				_month = value
			End Set
		End Property
		Public Property Year() As Integer
			Get
				Return _year
			End Get
			Set
				If value < 1000 OrElse value > 9999 Then
					Throw New NotSupportedException("Value not supported." & vbLf & "Expected value 1000 to 9999" & vbLf & "Actual value: " & value)
				End If
				_year = value
			End Set
		End Property

		<JsonProperty("BusinessKPITargets")> _
		Public Property KPITargets() As List(Of KPIMetrics)
			Get
				Return m_KPITargets
			End Get
			Set
				m_KPITargets = Value
			End Set
		End Property
		Private m_KPITargets As List(Of KPIMetrics)
	End Class
End Namespace
