Imports System.Collections.Generic
Imports System.IO
Imports System.Linq
Imports System.Text

Namespace Utilities
	Public Class FileUtilities
        Const jsonPath As String = ".\\Data"

        Public Shared Function ReadTextFromFile(filePath As String) As String
            Dim files = Directory.GetFiles(jsonPath)
            If System.IO.File.Exists(filePath) Then
				Try
					System.IO.File.SetAttributes(filePath, System.IO.FileAttributes.Normal)
				Catch
				End Try
				Dim text = File.ReadAllText(filePath)
				Return text
			Else
				Throw New System.IO.FileNotFoundException("File does not exist" & filePath)
			End If
		End Function

		Public Shared Sub WriteTextToFile(filePath As String, content As String)
			Try
				File.WriteAllText(filePath, content)
			Catch ex As Exception
				Throw ex
			End Try
		End Sub

		Public Shared Function LoadJSON(fileName As String) As String
            Dim json As String = String.Empty
            json = ReadTextFromFile(Path.Combine(jsonPath, fileName))
			Return json
		End Function

		Public Shared Sub WriteToJSON(fileName As String, content As String)
			WriteTextToFile(Path.Combine(jsonPath, fileName), content)
		End Sub
	End Class
End Namespace
