﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace Spread.ControlExplorer.Components
    Partial Public Class Header
        Inherits UserControl

        Public Delegate Sub HeaderNavigationHandler(ByVal sender As Object, ByVal e As HeaderNavigationEventArgs)
        Public Event OnHeaderNavigate As HeaderNavigationHandler

        Public Property Title As String
            Get
                Return _lblName.Text
            End Get
            Set(ByVal value As String)
                _lblName.Text = value
            End Set
        End Property

        Public Property Image As Image
            Get
                Return _pbLogo.Image
            End Get
            Set(ByVal value As Image)
                _pbLogo.Image = value
            End Set
        End Property

        Public Property HighlightColor As Color
            Get
                Return panel1.BackColor
            End Get
            Set(ByVal value As Color)
                panel1.BackColor = value
            End Set
        End Property

        Public Property ButtonBackColor As Color
            Get
                Return btnDownload.BackColor
            End Get
            Set(ByVal value As Color)
                btnDownload.BackColor = value
            End Set
        End Property

        Public Property ButtonForeColor As Color
            Get
                Return btnDownload.ForeColor
            End Get
            Set(ByVal value As Color)
                btnDownload.ForeColor = value
            End Set
        End Property

        Public Property BreadCrumbPath As String
            Get
                Return _breadCrumb.Text
            End Get
            Set(ByVal value As String)

                If _breadCrumb.Text <> value Then
                    _breadCrumb.Text = value
                    Dim path As String
                    For Each path In _breadCrumb.Text.Split("\"c)
                        _breadCrumb.AddPath(path, Nothing)
                    Next
                End If
            End Set
        End Property

        Public Property DownloadTitle As String
            Get
                Return btnDownload.Text
            End Get
            Set(ByVal value As String)
                btnDownload.Text = value
            End Set
        End Property

        Public Property DownloadLink As String

        Public Sub New()
            InitializeComponent()
        End Sub

        Protected Overrides Sub OnBackColorChanged(ByVal e As EventArgs)
            MyBase.OnBackColorChanged(e)

            For Each control1 As Object In Me.Controls
                TryCast(control1, Control).BackColor = Me.BackColor

            Next
        End Sub

        'Protected Overrides Sub OnForeColorChanged(ByVal e As EventArgs)
        '    MyBase.OnForeColorChanged(e)
        '    _breadCrumb.ForeColor = CSharpImpl.__Assign(_lblName.ForeColor, ForeColor)
        'End Sub
        Protected Overrides Sub OnForeColorChanged(ByVal e As EventArgs)
            MyBase.OnForeColorChanged(e)
            _breadCrumb.ForeColor = ForeColor
            _lblName.ForeColor = ForeColor
        End Sub

        Private Sub btnPrevious_Click(ByVal sender As Object, ByVal e As EventArgs)

            ' OnHeaderNavigate?.Invoke()
            RaiseEvent OnHeaderNavigate(Me, New HeaderNavigationEventArgs(NavigationDirectionEnum.Previous))
            'OnHeaderNavigate.Invoke(Me, New HeaderNavigationEventArgs(NavigationDirectionEnum.Previous))
        End Sub

        Private Sub btnNext_Click(ByVal sender As Object, ByVal e As EventArgs)
            RaiseEvent OnHeaderNavigate(Me, New HeaderNavigationEventArgs(NavigationDirectionEnum.[Next]))
            'OnHeaderNavigate.Invoke(Me, New HeaderNavigationEventArgs(NavigationDirectionEnum.[Next]))
        End Sub

        Private Sub btnDownload_Click(ByVal sender As Object, ByVal e As EventArgs)
            System.Diagnostics.Process.Start(DownloadLink)
        End Sub

        Private Sub NavMouseEnter(ByVal sender As Object, ByVal e As EventArgs)
            Me.Cursor = Cursors.Hand
        End Sub

        Private Sub NavMouseLeave(ByVal sender As Object, ByVal e As EventArgs)
            Me.Cursor = Cursors.[Default]
        End Sub

        'Private Class CSharpImpl
        '    <Obsolete("Please refactor calling code to use normal Visual Basic assignment")>
        '    Shared Function __Assign(Of T)(ByRef target As T, value As T) As T
        '        target = value
        '        Return value
        '    End Function
        'End Class
    End Class

    Public Class HeaderNavigationEventArgs
        Inherits EventArgs

        Public Property Direction As NavigationDirectionEnum

        Public Sub New(ByVal dir As NavigationDirectionEnum)
            Me.Direction = dir
        End Sub

        '    Private Class CSharpImpl
        '        <Obsolete("Please refactor calling code to use normal Visual Basic assignment")>
        '        Shared Function __Assign(Of T)(ByRef target As T, value As T) As T
        '            target = value
        '            Return value
        '        End Function
        '    End Class
    End Class

    Public Enum NavigationDirectionEnum
        [Next]
        Previous
        First
        Last
    End Enum
End Namespace
