Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Spread.Common.Features.Spread.Common.Features.Utilities





Namespace Spread.ControlExplorer.Components
	Public Partial Class SampleHost
		Inherits UserControl
		Public Delegate Sub SampleAddHandler(sender As Object, e As EventArgs)
		Public Event OnSampleAdded As SampleAddHandler

    Public Sub New()
			InitializeComponent()
      ToggleAdditionalInformation(False)
    End Sub

    Public Property Sample() As Control
			Get
				Return Me.pnlHost.Controls("sample")
			End Get
			Set
				If value IsNot Nothing Then
                    Dim old As Object = Me.pnlHost.Controls("sample")
                    If old IsNot Nothing Then
						old.Name = "oldSample"
					End If
					value.Name = "sample"
					value.Dock = DockStyle.Fill
					Me.pnlHost.Controls.Add(value)
					Me.pnlHost.Controls.RemoveByKey("oldSample")
					Me.tabControl.SelectedIndex = 0
					RaiseEvent OnSampleAdded(Me, EventArgs.Empty)
				End If
			End Set
		End Property

		Public Property ShowBorder() As Boolean
			Get
				Return Me.pnlHost.ShowBorder
			End Get
			Set
				Me.pnlHost.ShowBorder = value
			End Set
		End Property

		Private _Description As String = Nothing
		Public Property Description() As String
			Get
				Return rtbDesc.Rtf
			End Get
			Set
				_Description = value
				If Not String.IsNullOrEmpty(value) Then
					rtbDesc.Clear()
					Try
						rtbDesc.Rtf = value
					Catch generatedExceptionName As System.ArgumentException
						rtbDesc.Text = value
					End Try
					If Not Me.tabControl.TabPages.Contains(descriptionTab) Then
						Me.tabControl.TabPages.Insert(0, descriptionTab)
					End If
					ToggleAdditionalInformation()
				Else
					If Me.tabControl.TabPages.Contains(descriptionTab) Then
						Me.tabControl.TabPages.Remove(descriptionTab)
					End If
					ToggleAdditionalInformation()
				End If
			End Set
		End Property

		Private _Code As String = Nothing
		Public Property Code() As String
			Get
				Return rtbCode.Text
			End Get
			Set
				_Code = value
        If Not String.IsNullOrEmpty(value) Then
					rtbCode.Clear()
          rtbCode.Text = Value
          Try
           ' rtbCode.FormatRfToCS()
           Catch ex As Exception

          End Try


          If Not Me.tabControl.TabPages.Contains(codeTab) Then
						Me.tabControl.TabPages.Add(codeTab)
					End If
					ToggleAdditionalInformation()
				Else
					If Me.tabControl.TabPages.Contains(codeTab) Then
						Me.tabControl.TabPages.Remove(codeTab)
					End If
					ToggleAdditionalInformation()
				End If
			End Set
		End Property

		Public Sub ToggleAdditionalInformation(Optional show As Boolean = True)
			tLP.RowStyles(0).SizeType = SizeType.Percent
			tLP.RowStyles(1).SizeType = SizeType.Percent
			Dim _m As Integer = 60
			Dim _a As Integer = 40
			If show Then
				show = Not String.IsNullOrWhiteSpace(_Description) OrElse Not String.IsNullOrWhiteSpace(_Code)
			End If
			If Not show Then
				_m = 100
				_a = 0
			End If
			tLP.RowStyles(0).Height = _m
			tLP.RowStyles(1).Height = _a

		End Sub
  End Class
End Namespace
