Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports System.Collections.ObjectModel
Imports System.Collections.Specialized

Namespace Spread.ControlExplorer.Components
	Public Partial Class TileControl
		Inherits UserControl
		Public Property Groups() As ObservableCollection(Of TileGroup)
			Get
				Return m_Groups
			End Get
			Private Set
				m_Groups = Value
			End Set
		End Property
		Private m_Groups As ObservableCollection(Of TileGroup)

		Public Sub New()
			InitializeComponent()
			Groups = New ObservableCollection(Of TileGroup)()
			AddHandler Groups.CollectionChanged, AddressOf OnGroupsCollectionChanged
		End Sub

		Private Sub OnGroupsCollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
			Me.SuspendLayout()
			If e.NewItems IsNot Nothing AndAlso e.NewItems.Count > 0 Then
				For Each newItem As TileGroup In e.NewItems
					flowLayoutPanel1.Controls.Add(newItem)
				Next
			End If

			If e.OldItems IsNot Nothing AndAlso e.OldItems.Count > 0 Then
				For Each oldItem As TileGroup In e.OldItems
					flowLayoutPanel1.Controls.Remove(oldItem)
				Next
			End If

			If e.Action = System.Collections.Specialized.NotifyCollectionChangedAction.Reset Then
				flowLayoutPanel1.Controls.Clear()
			End If
			Me.ResumeLayout()
		End Sub

		Private _HoverColor As Color
		Public Property HoverColor() As Color
			Get
				Return _HoverColor
			End Get
			Set
				If _HoverColor <> value Then
					_HoverColor = value
				End If
			End Set
		End Property
	End Class
End Namespace
