Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports System.Collections.ObjectModel
Imports System.Collections.Specialized

Namespace Spread.ControlExplorer.Components
	Public Partial Class TileGroup
		Inherits UserControl
		Public Property GroupName() As String
			Get
				Return m_GroupName
			End Get
			Set
				m_GroupName = Value
			End Set
		End Property
		Private m_GroupName As String

		Public Property Tiles() As ObservableCollection(Of TileView)
			Get
				Return m_Tiles
			End Get
			Private Set
				m_Tiles = Value
			End Set
		End Property
		Private m_Tiles As ObservableCollection(Of TileView)
		Public Sub New()
			InitializeComponent()
			Tiles = New ObservableCollection(Of TileView)()
			AddHandler Tiles.CollectionChanged, AddressOf OnTilesCollectionChanged
		End Sub

		Public Sub New(groupName__1 As String)
			Me.New()
			GroupName = groupName__1
		End Sub

		Private Sub OnTilesCollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)

			If e.NewItems IsNot Nothing AndAlso e.NewItems.Count > 0 Then
				For Each newItem As TileView In e.NewItems
					flowLayoutPanel1.Controls.Add(newItem)
				Next
			End If
			If e.OldItems IsNot Nothing AndAlso e.OldItems.Count > 0 Then
				For Each oldItem As TileView In e.OldItems
					flowLayoutPanel1.Controls.Remove(oldItem)
				Next
			End If
		End Sub

		Private _HoverColor As Color
		Public Property HoverColor() As Color
			Get
				If TypeOf Me.Parent.Parent.Parent Is TileControl Then
					Return TryCast(Me.Parent.Parent.Parent, TileControl).HoverColor
				Else
					Return _HoverColor
				End If
			End Get
			Set
				If _HoverColor <> value Then
					_HoverColor = value
				End If
			End Set
		End Property

		Public Overrides Function GetPreferredSize(proposedSize As Size) As Size
            Dim size As Size = proposedSize
            If Parent IsNot Nothing AndAlso Tiles.Count > 0 Then
                Dim tile As Object = Tiles.First()
                Dim tileHeight As Integer = CInt(tile.Height) + CInt(tile.Margin.Vertical) + CInt(tile.Padding.Vertical)
                Dim tileWidth As Integer = CInt(tile.Width) + CInt(tile.Margin.Horizontal) + CInt(tile.Padding.Horizontal)
                Dim scrollWidth As Integer = If(TryCast(Parent, Panel).VerticalScroll.Visible, SystemInformation.VerticalScrollBarWidth, 0)
                size.Width = Parent.Width - Parent.Margin.Horizontal - Parent.Padding.Horizontal - scrollWidth
                Dim colsCount As Integer = CInt(size.Width \ tileWidth)
                Dim rowCount As Integer = CInt(Math.Ceiling(Tiles.Count / colsCount))
                size.Height = CInt(Math.Truncate(tileHeight * rowCount))
			End If
			Return size
		End Function
	End Class
End Namespace
