Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Spread.Common.Features.Spread.Common.Features.Core

Namespace Spread.ControlExplorer.Components
	Public Partial Class TileView
		Inherits UserControl
		Private _HoverColor As Color
		Public Property HoverColor() As Color
			Get
				If TypeOf Me.Parent.Parent Is TileGroup Then
					Return TryCast(Me.Parent.Parent, TileGroup).HoverColor
				Else
					Return _HoverColor
				End If
			End Get
			Set
				If _HoverColor <> value Then
					_HoverColor = value
				End If
			End Set
		End Property
		Public Shadows Property Text() As String
			Get
				Return lblCardName.Text
			End Get
			Set
				lblCardName.Text = value
			End Set
		End Property

		Private img As Image
		Public Property Image() As Image
			Get
				Return img
			End Get
			Set
				img = value
				picBox.Image = GetThumbnail(img)
			End Set
		End Property

		Public Sub New()
			InitializeComponent()
			AutoSize = False
			Margin = New Padding(10)
            AddHandler lblCardName.Click, Sub(s, e) Me.OnClick(e)
            AddHandler picBox.Click, Sub(s, e) Me.OnClick(e)
            AddHandler pnlForPb.Click, Sub(s, e) Me.OnClick(e)
            AddHandler lblCardName.MouseEnter, Sub(s, e) Me.OnMouseEnter(e)
            AddHandler picBox.MouseEnter, Sub(s, e) Me.OnMouseEnter(e)
            AddHandler pnlForPb.MouseEnter, Sub(s, e) Me.OnMouseEnter(e)
            AddHandler lblCardName.MouseLeave, Sub(s, e) Me.OnMouseLeave(e)
            AddHandler picBox.MouseLeave, Sub(s, e) Me.OnMouseLeave(e)
            AddHandler pnlForPb.MouseLeave, Sub(s, e) Me.OnMouseLeave(e)
        End Sub

		Private Function GetThumbnail(image As Image) As Image
			Return image.GetThumbnailImage(picBox.PreferredSize.Width, picBox.PreferredSize.Height, Nothing, New IntPtr())
		End Function

		Protected Overrides Sub OnMouseEnter(e As EventArgs)
			MyBase.OnMouseEnter(e)
			Me.Cursor = Cursors.Hand
			Me.lblCardName.ForeColor = HoverColor
		End Sub

		Protected Overrides Sub OnMouseLeave(e As EventArgs)
			MyBase.OnMouseLeave(e)
			Me.Cursor = Cursors.[Default]
			Me.lblCardName.ForeColor = Me.Parent.ForeColor
		End Sub

		Private Sub pnlForPb_Paint(sender As Object, e As PaintEventArgs)
            Dim rect As Rectangle = New Rectangle(0, 0, pnlForPb.Width - 1, pnlForPb.Height - 1)
            e.Graphics.DrawRectangle(New Pen(Color.FromArgb(221, 221, 221)), rect)
		End Sub
	End Class
End Namespace
