Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms


Namespace Spread.Common.Features.Explorer.CustomControls
    Partial Public Class BreadCrumb
        Inherits UserControl
        Public Sub New()
            InitializeComponent()
        End Sub

        Public Sub Path(paths As Dictionary(Of String, EventHandler))
            Me.Clear()
            For Each path__1 As Object In paths
                Me.AddPath(path__1.Key, path__1.Value)
            Next
        End Sub

        Public Sub Clear()
            Me.fLP.Controls.Clear()
        End Sub

        Public Sub AddPath(name As String, clickDelegate As EventHandler)
            Dim label As New Label() With {
                .Text = name,
                .Tag = Me.fLP.Controls.OfType(Of Label)().Count(),
                .AutoSize = True
            }
            If Me.fLP.Controls.OfType(Of Label)().Count() <> 0 Then
                label.Text = "/  " & label.Text
            End If



            AddHandler label.MouseEnter, AddressOf MouseEntered

            AddHandler label.MouseLeave, AddressOf MouseLeave1
            AddHandler label.Click, clickDelegate
            AddHandler label.Click, AddressOf Click1
            Me.fLP.Controls.Add(label)
        End Sub
        Sub MouseEntered()
            Me.Cursor = Cursors.Hand
        End Sub
        Sub MouseLeave1()
            Me.Cursor = Cursors.[Default]
        End Sub

        Sub Click1(s, e)
            Dim removeControls As Object = Me.fLP.Controls.OfType(Of Label)().Where(Function(l) CInt(TryCast(l, Label).Tag) > CInt(TryCast(s, Label).Tag)).ToList()
            For Each removeControl As Object In CType(removeControls, IEnumerable(Of Object))
                Me.fLP.Controls.Remove(CType(removeControl, Control))
            Next

        End Sub

        Protected Overrides Sub Finalize()
            MyBase.Finalize()
        End Sub
    End Class
End Namespace
