Imports System.Collections.Generic
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace Spread.Common.Features.Explorer.CustomControls
    <System.ComponentModel.DesignerCategory("Code")>
    Public Class PanelEx
        Inherits Panel
        Private _ShowBorder As Boolean = True
        Public Property ShowBorder() As Boolean
            Get
                Return _ShowBorder
            End Get
            Set
                _ShowBorder = Value
                Me.Invalidate()
            End Set
        End Property

        Private _BorderColor As Color = Color.FromArgb(221, 221, 221)
        Public Property BorderColor() As Color
            Get
                Return Me._BorderColor
            End Get
            Set
                If Me._BorderColor <> Value Then
                    Me._BorderColor = Value
                    Invalidate()
                End If
            End Set
        End Property
        Public Sub New()
            SetStyle(ControlStyles.UserPaint Or ControlStyles.ResizeRedraw Or ControlStyles.DoubleBuffer Or ControlStyles.AllPaintingInWmPaint, True)
        End Sub

        Protected Overrides Sub OnPaint(e As PaintEventArgs)
            If ShowBorder Then
                Dim rect As Rectangle = New Rectangle(0, 0, Me.Width - 1, Me.Height - 1)
                e.Graphics.DrawRectangle(New Pen(BorderColor), rect)
            End If
        End Sub

    End Class
End Namespace
