Imports System.Collections.Generic
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace Spread.ControlExplorer.Components
    Public Class TextBoxEx
        Inherits TextBox
        Const WmPaint As Integer = 15

        Private _Placeholder As String = ""
        Public Property Placeholder() As String
            Get
                Return _Placeholder
            End Get
            Set
                _Placeholder = Value
                Me.Refresh()
            End Set
        End Property

        Protected Overrides Sub OnTextChanged(e As EventArgs)
            MyBase.OnTextChanged(e)
            Me.Refresh()
        End Sub

        Protected Overrides Sub WndProc(ByRef m As Message)
            MyBase.WndProc(m)

            Select Case m.Msg
                Case WmPaint
                    Using graphics__1 = Graphics.FromHwnd(Handle)
                        If String.IsNullOrEmpty(Me.Text) AndAlso Not String.IsNullOrEmpty(Me.Placeholder) Then
                            graphics__1.DrawString(Me.Placeholder, Me.Font, Brushes.DimGray, New PointF(0, 0))
                        End If
                    End Using
                    Exit Select
            End Select
        End Sub
    End Class
End Namespace
