Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Reflection
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms
Imports Spread.Common.Features.Spread

Namespace Spread.Common.Features.Sample
    Partial Public Class BaseForm
        Inherits Form
        Public Property Title() As String
            Get
                Return m_Title
            End Get
            Set
                m_Title = Value
            End Set
        End Property
        Private m_Title As String

        Public Property [NameSpace]() As String
            Get
                Return m_NameSpace
            End Get
            Set
                m_NameSpace = Value
            End Set
        End Property
        Private m_NameSpace As String

        Public Property Samples() As List(Of Type)
            Get
                Return m_Samples
            End Get
            Private Set
                m_Samples = Value
            End Set
        End Property
        Private m_Samples As List(Of Type)
        Public Sub New()
            InitializeComponent()
            Samples = New List(Of Type)()
            AddHandler Me.Load, AddressOf OnLoad
            WindowState = FormWindowState.Maximized
        End Sub

        Private Overloads Sub OnLoad(sender As Object, e As EventArgs)
            If DesignMode Then
                Return
            End If
            InitializeDemos()
            AddHandler TreeView.SelectionChanged, AddressOf TreeView_SelectionChanged
            TreeView.SelectedNode = TreeView.Nodes(0)
        End Sub

        Private Sub InitializeDemos()
            If Samples.Count = 0 Then
                Dim nspace As String = If(String.IsNullOrEmpty([NameSpace]), Me.[GetType]().[Namespace], [NameSpace])
                Samples.AddRange(Assembly.GetEntryAssembly().GetTypes().Where(Function(t) t.IsSubclassOf(GetType(BaseSampleControl)) AndAlso t.[Namespace] = nspace).OrderBy(Function(t) t.Name).ToList())
            End If
            Samples.ForEach(Sub(t)
                                Dim name As String = String.Empty
                                Using obj As BaseSampleControl = TryCast(Activator.CreateInstance(t), BaseSampleControl)
                                    name = If(obj IsNot Nothing, obj.Name, t.Name.Replace("Demo", ""))
                                End Using
                                Dim node As Object = treeView.Nodes.Add(name)
                                node.Tag = t
                                node.ShowImage = False

                            End Sub)
        End Sub

        Private Sub TreeView_SelectionChanged(sender As Object, e As ControlExplorer.Components.StackNodeEventArgs)
            Dim type As Object = TryCast(e.Node.Tag, Type)
            Dim obj As Control = TryCast(Activator.CreateInstance(type), Control)
            obj.Dock = DockStyle.Fill
            If obj IsNot Nothing Then
                pnlDemos.Controls.Clear()
                pnlDemos.Controls.Add(obj)
                If String.IsNullOrEmpty(Title) Then
                    Me.Text = e.Node.Text
                Else
                    Me.Text = String.Format("{0} : {1}", Title, e.Node.Text)
                End If
            End If
        End Sub
    End Class
End Namespace
